/****************************************************
 *                                                   
 *    File Name : inv.c                              
 *                                                   
 *    Author    : KIM, DONGMIN (kimd@top.cis.syr.edu)
 *                                                   
 ****************************************************/

#include <stdio.h>
#include <malloc.h>
#include <sys/types.h>
#include <unistd.h>
#include <math.h>
#include <string.h>

main(argc,argv)
     int  argc;
     char *argv[];
{
  int nsize;
  int inch1, outch1;
  char	**buf;
  char tmp[10];
  char *temp;
  int i, j, k;
  int matrix_size, type, size;
  int nslave, my_id, to, row, load, from, column;
  int LU;
  float **Matrix, **I;
  float L, U, divide, mult;
  float element, zero;
  char	*out1_msg;

  long  total_elapsed;
  FILE  *fd, *fd1;
  char  *task_name;
  int   task_id;
  char  file_name[100];
  char  *io_file;
  int   *counter;
  char  *buf2;
  int   *tmp_matrix_size;
  int   total_size;
  char  *send_buf;
  float *tmp_float;

  char input_file[30];
  char output_INV[30];

  strcpy(input_file, argv[1]);
  strcpy(output_INV, argv[2]);

  /* external file */
  /* get input data from file */
  fd1 = fopen(input_file, "r");

  if ( fd1 == NULL ) {
    printf("\ncannot find file!\n");
    exit(1);
  }
 
  /* read the size of the matrix. */
  fscanf( fd1, "%d", &matrix_size );

  Matrix =  (float **) malloc(matrix_size * sizeof(float *));
  if (Matrix == NULL) {
    printf("malloc error at Matrix");
  }
  for ( i = 0 ; i < matrix_size ; i++ ) {
    Matrix[i] = (float *) malloc(matrix_size * sizeof(float));
    if (Matrix[i] == NULL) {
      printf("malloc error at Matrix[%d]", i);
    }
  }

  /* read from the file */
  for ( i = 0 ; i < matrix_size ; i++ ) {
    for ( j = 0 ; j < matrix_size ; j++ ) {
      fscanf(fd1, "%f", &element);
      Matrix[i][j] = element;
    }
  }
  fclose(fd1);

  I =  (float **) malloc(matrix_size * sizeof(float *));
  for ( i = 0 ; i < matrix_size ; i++ ) {
    I[i] = (float *) malloc(matrix_size * sizeof(float));
  }

  sec_timer_reset();

  /* Initiate the Identity matrix */
  for ( i = 0 ; i < matrix_size ; i++ ) {
    for ( j = 0 ; j < matrix_size ; j++ ) {
      if ( i == j ) {
	I[i][j] = 1.0;
      }
      else {
	I[i][j] = 0.0;
      }
    }
  }

  L = 0.;
  U = 0.;

  /* check if the matrix is L, U or neither */
  for ( i = 0 ; i < matrix_size ; i++ ) {
    for ( j = 0 ; j < matrix_size ; j++ ) {
      if ( i < j ) {
	L = L + Matrix[i][j];
      }
      else if ( i > j ) {
	U = U + Matrix[i][j];
      }
      else {
      }
    }
  }

  if ( L == 0.0 ) { /* the matrix is lower matrix */
    LU = 1;
  }
  else if ( U == 0.0 ) {  /* the matrix is upper matrix */
    LU = 2;
  }
  else { /* neither */
    LU = 0;
  }

    /* convert the matrix to upper matrix if it is neither L nor U */
  if ( LU == 0 ) {
    LU == 2;
    for ( i = 0 ; i < matrix_size - 1 ; i++ ) {
      for ( j = i + 1 ; j < matrix_size ; j++ ) {
	divide = Matrix[j][i];
	mult = Matrix[i][i];
	if ( divide != 0 ) {
	  for ( k = 0 ; k < matrix_size ; k++ ) {

	    Matrix[j][k] = Matrix[i][k] - ((mult / divide) * Matrix[j][k]);

	    I[k][j] = I[k][i] - ((mult / divide) * I[k][j]);
	  }
	}
	Matrix[j][i] = 0.;
      }
    }
  }

  compute_inverse(Matrix, I, matrix_size, LU);


  total_elapsed = sec_timer_elapsed();

  printf("Inverse Matrix - matrix size %d : %d\n", matrix_size, total_elapsed);

  /**
  // external file
  fd1 = fopen(output_INV, "w");
 
  if ( fd1 == NULL ) {
    printf("\ncannot find file!\n");
  }
  else {
    fprintf(fd1, "%d\n", matrix_size);
    for ( i = 0 ; i < matrix_size ; i++ ) {
      for ( j = 0 ; j < matrix_size ; j++ ) {
	fprintf( fd1, "%7.3f", Matrix[i][j]);
      }
      fprintf(fd1, "\n");
    }
    fclose(fd1);
  }
  **/
}

compute_inverse(Matrix, I, matrix_size, LU)
float **Matrix, **I;
int  matrix_size, LU;
{
  int	 i, j, k, step, type, from, to;

  int	 current_id, current_row, nslave;
  int	 total_size;
  float **inverse;
  float divisor, sum;
  int	 current, current_slave;


  inverse = (float **) malloc(matrix_size * sizeof(float *));
  for ( i = 0 ; i < matrix_size ; i++ )
    inverse[i] = (float *) malloc(matrix_size * sizeof(float));

  /* Warning :
     the inverse matrix of L (or U) is also L (or U).
     So we can reduce the computation time if we notice this.
  */
  if ( LU == 1 ) { /* L matrix */

    for ( k = 0 ; k < matrix_size ; k++ ) {
      for ( i = 0 ; i < matrix_size ; i++ ) {
	sum = 0.;
	for ( j = 0 ; j < i ; j++ ) {
	  sum = sum + Matrix[i][j] * inverse[k][j];
	}
	inverse[k][i] = I[i][k] - sum;
      }
    }
  }
  else {

    for ( k = 0 ; k < matrix_size ; k++ ) {
      for ( i = matrix_size - 1 ; i >= 0 ; i-- ) {
	divisor = Matrix[i][i];
	sum = 0.;
	for ( j = i + 1 ; j < matrix_size ; j++ ) {
	  sum = sum + Matrix[i][j] * inverse[k][j];
	}
	inverse[k][i] = ( I[i][k] - sum ) / divisor;
      }
    }
  }

  for ( i = 0 ; i < matrix_size ; i++ ) {
    for ( j = 0 ; j < matrix_size ; j++ ) {
      Matrix[i][j] = inverse[i][j];
    }
  }

}

